from django.db import models
from resource_manager.models import *

#Example MySQL resources
class MySQLHost(models.Model):
    name = models.CharField(max_length=256)
    def __unicode__(self):
        return self.name
class MySQLDatabase(BaseResource):
    name = models.CharField(max_length=256)
    host = models.ForeignKey('MySQLHost')

    #Members to allow synchronisation
    current_name = models.CharField(max_length=256)
    def update_done(self):
        self.current_name = self.name

    create_script = 'mysqldb_create.sh'
    def create_args(self):
        return [self.name, self.host.name]
    suspend_script = 'mysqldb_suspend.sh'
    def suspend_args(self):
        return [self.current_name, self.host.name]
    delete_script = 'mysqldb_delete.sh'
    def delete_args(self):
        return [self.current_name, self.host.name]

    def __unicode__(self):
        return self.name + " on " + self.host.name

User.add_to_class("email", models.CharField(max_length=256, blank=True))
