#!/usr/bin/python
import settings
from resource_manager.models import *
from datetime import datetime

resource_classes = []
for app in settings.INSTALLED_APPS:
    appmod = __import__(app + ".models")
    if hasattr(appmod, 'models'):
        for clsname in dir(appmod.models):
            cls = getattr(appmod.models, clsname)
            if hasattr(cls, '__bases__'):
                if issubclass(cls, BaseResource) and cls != BaseResource:
                    resource_classes += [cls]
print resource_classes
for res in resource_classes:
    todo = res.objects.filter(processed=False)
    for obj in todo:
        script = None
        args = []
        doupdate = False
        newstatus = obj.status
        if obj.status == RESOURCE_STATUS_TOBEACTIVE:
            script = obj.create_script
            args = obj.create_args()
            newstatus = RESOURCE_STATUS_ACTIVE
        elif obj.status == RESOURCE_STATUS_TOBECLOSED:
            script = obj.delete_script
            args = obj.delete_args()
            newstatus = RESOURCE_STATUS_CLOSED
        else:
            #TODO Perform update
            print 'run: ', obj.update_script, obj.update_args()
            obj.update_done()
        
        if obj.status == RESOURCE_STATUS_TOBESUSPENDED:
            script = obj.suspend_script
            args = obj.suspend_args()
            newstatus = RESOURCE_STATUS_SUSPENDED
            doupdate = True

        if script:
            print 'run: ', script, args
            #TODO - run the script, and check return value for errors

        obj.processed = True
        obj.modified = datetime.now()
        obj.status = newstatus
        obj.save(processed_done=True)

